'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fromEvent = undefined;

var _rx = require('rx');

function fromEvent(element, eventName) {
  var useCapture = arguments.length <= 2 || arguments[2] === undefined ? false : arguments[2];

  return _rx.Observable.create(function (observer) {
    var next = function next(event) {
      return observer.onNext(event);
    };
    element.addEventListener(eventName, next, useCapture);

    return function () {
      return element.removeEventListener(eventName, next, useCapture);
    };
  }).share();
}

exports.fromEvent = fromEvent;