'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeIsStrictlyInRootScope = makeIsStrictlyInRootScope;

var _isolate = require('./modules/isolate');

function makeIsStrictlyInRootScope(scope) {
  return function isStrictlyInRootScope(leaf) {
    for (var el = leaf; el; el = el.parentElement) {
      var _scope = (0, _isolate.isIsolatedElement)(el);
      if (_scope && _scope !== scope) {
        return false;
      }
      if (_scope) {
        return true;
      }
    }
    return true;
  };
}